// gridDlg.cpp : implementation file
//

#include "stdafx.h"
#include "grid.h"
#include "gridDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "SimpleDataObject_i.c"
#include "IGetAsADORecordset.h"
#include "IGetAsADORecordset_i.c"


#include "AFXPRIV.H"
#include "COMDEF.H."

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridDlg dialog

CGridDlg::CGridDlg(CWnd* pParent /*=NULL*/)
	:  CDialog(CGridDlg::IDD, pParent),
      m_pDataObject(0),
      m_pRs(0)
{
	//{{AFX_DATA_INIT(CGridDlg)
	m_colWidth = 12;
	m_numCols = 5;
	m_numRows = 5;
	m_cursorLocation = 1;
	m_lockType = 3;
	m_cursorType = 2;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CGridDlg::~CGridDlg()
{
   if (m_pDataObject)
   {
      m_pDataObject->Release();
   }
}

void CGridDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGridDlg)
	DDX_Control(pDX, IDC_DATAGRID1, m_dataGrid);
	DDX_Text(pDX, IDC_COL_WIDTH, m_colWidth);
	DDV_MinMaxUInt(pDX, m_colWidth, 1, 100);
	DDX_Text(pDX, IDC_NUM_COLS, m_numCols);
	DDV_MinMaxUInt(pDX, m_numCols, 1, 25);
	DDX_Text(pDX, IDC_NUM_ROWS, m_numRows);
	DDV_MinMaxUInt(pDX, m_numRows, 1, 25);
	DDX_Radio(pDX, IDC_CURSOR_LOCATION, m_cursorLocation);
	DDX_Radio(pDX, IDC_LOCK_TYPE, m_lockType);
	DDX_Radio(pDX, IDC_CURSOR_TYPE, m_cursorType);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGridDlg, CDialog)
	//{{AFX_MSG_MAP(CGridDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MAKE_TABLE, OnMakeTable)
	ON_BN_CLICKED(IDC_ADD_ROW, OnAddRow)
	ON_BN_CLICKED(IDC_QI_RECORDSET, OnQiRecordset)
	ON_BN_CLICKED(IDC_REMOVE_ROW, OnRemoveRow)
	ON_BN_CLICKED(IDC_GET_RECORDSET, OnGetRecordset)
	ON_BN_CLICKED(IDC_DATA_GRID, OnDataGrid)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridDlg message handlers

BOOL CGridDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGridDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGridDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGridDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

inline void ThrowOnFailure(HRESULT hr)
{
   if (FAILED(hr))
   {
      throw hr;
   }
}

void CGridDlg::OnMakeTable() 
{
   UpdateData();

   try
   {
      if (m_pDataObject)
      {
         m_pDataObject->Release();
         m_pDataObject = 0;
      }

      USES_CONVERSION;

      HRESULT hr = CoCreateInstance(CLSID_MyDataObject, 0, CLSCTX_ALL, IID_IMyDataObject, (void**) &m_pDataObject);

      if (SUCCEEDED(hr))
      {
         ThrowOnFailure(m_pDataObject->SetColumnSize(m_colWidth));

         unsigned int i;

         for (i = 1; i <= m_numCols; i++)
         {
            CString columnName;

            columnName.Format("Col %d", i);

            long index;

            ThrowOnFailure(m_pDataObject->AddColumn(A2BSTR(columnName), &index));
         }

         for (i = 1; i <= m_numRows; i++)
         {
            long index;
            ThrowOnFailure(m_pDataObject->AddRow(&index));
      
            for(unsigned int y = 1; y <= m_numCols; y++)
            {
               CString data;

               data.Format("Row %d Col %d", i, y);

               ThrowOnFailure(m_pDataObject->SetAt(i, y, A2BSTR(data)));
            }
         }
      }
      else
      {
         MessageBox("Failed to create Data Object");
      }
   }
   catch (HRESULT &)
   {
      MessageBox("Failed");  
   }
}

void CGridDlg::OnAddRow() 
{
	// TODO: Add your control notification handler code here
	
}

void CGridDlg::OnQiRecordset() 
{
   if (!m_pDataObject)
   {
      MessageBeep(1);
      return;
   }

   if (m_pRs)
   {
      m_pRs->Release();
      m_pRs = 0;
   }

   HRESULT hr = m_pDataObject->QueryInterface(__uuidof(ADODB::_Recordset), (void**)&m_pRs);

   if (FAILED(hr))
   {
      MessageBox("Failed to QI to recordset");
   }
   
}

void CGridDlg::OnRemoveRow() 
{
	// TODO: Add your control notification handler code here
	
}

void CGridDlg::OnGetRecordset() 
{
   UpdateData();

   if (!m_pDataObject)
   {
      MessageBeep(1);
      return;
   }

   if (m_pRs)
   {
      m_pRs->Release();
      m_pRs = 0;
   }

   IGetAsADORecordset *pGetAsRs = 0;

   HRESULT hr = m_pDataObject->QueryInterface(IID_IGetAsADORecordset, (void**)&pGetAsRs);

   if (SUCCEEDED(hr))
   {
      _variant_t varRs;

      hr = pGetAsRs->GetAsRecordset(GetCursorLocation(), GetLockType(), GetCursorType(), &varRs);

      if (FAILED(hr))
      {
         MessageBox("GetAsRecordset failed");
      }
      
      hr = varRs.punkVal->QueryInterface(__uuidof(ADODB::_Recordset), (void**)&m_pRs);

      if (FAILED(hr))
      {
         MessageBox("Failed to QI to recordset");
      }
         
      pGetAsRs->Release();
   }
   else
   {
      MessageBox("Failed to QI to IGetAsADORecordset");
   }
}

void CGridDlg::OnDataGrid() 
{
   m_dataGrid.SetRefDataSource(m_pRs);
}

CursorLocationEnum CGridDlg::GetCursorLocation()
{
   return (m_cursorLocation == 0) ? adUseClient : adUseServer;
}

LockTypeEnum CGridDlg::GetLockType()
{
   switch (m_lockType)
   {
      case 0 :

         return adLockReadOnly;

      case 1 :

         return adLockPessimistic;

      case 2 :

         return adLockOptimistic;

   }

   return adLockBatchOptimistic;
}

CursorTypeEnum CGridDlg::GetCursorType()
{
   switch (m_lockType)
   {
      case 0 :

         return adOpenForwardOnly;

      case 1 :

         return adOpenKeyset;

      case 2 :

         return adOpenDynamic;

   }

   return adOpenStatic;
}

void CGridDlg::OnTest() 
{
   OnMakeTable();
   OnGetRecordset();
   OnDataGrid();
}
